# WEB-T Translator for TMGMT

This module provides WEB-T as a translator for the [Drupal TMGMT module](https://www.drupal.org/project/tmgmt).

WEB-T is the free Website Translation Tool of the European Commission. [Read more](https://website-translation.language-tools.ec.europa.eu/index_en)

This module depends on the [WEB-T](https://www.drupal.org/project/webt) module that provides the translation service for this provider.

## Install

Download this module via [composer](https://www.drupal.org/docs/extending-drupal/installing-modules#s-add-a-module-with-composer) and you will get all dependencies automatically.

Then [enable the module](https://www.drupal.org/docs/extending-drupal/installing-modules#s-step-2-install-the-module) via backend or drush. All other required modules are activated automatically. 

## Configuration

WEB-T module automatically translates entities an other Drupal items. To work correctly with TMGMT, you must deactivate **Auto-translate on save/load?** on `/admin/config/regional/webt` > Advanced.

You need [account and API Key](https://webgate.ec.europa.eu/etranslation/public/requestApiKey.html) from WEBT.

## Allow access to callback urls

WEB-T uses callback URLs to send the translated content. You must ensure that these URLs are accessible from the Internet.

These paths are: `/etranslation/translation/{id}` and `/etranslation/error/{id}` (possibly with language prefix).

The agent is `eTranslation/1.0`.

The IP subnet is probably 158.169.128.0/17 from the European Commission's AS42848.

## Configure TMGMT step by step

Here is a short introduction if you are using TMGMT for the first time:

You have to install and configure TMGMT and sources for translation. If you only want to translate content, activate these modules:

- tmgmt (Translation Management Core)
- tmgmt_content (Content Entity Source)
- tmgmt_webt (WEB-T Translator)

### Configure WEB-T

First you need an application name and password. You can setup an account [here](https://website-translation.language-tools.ec.europa.eu/automated-translation_en),

Open `/admin/config/regional/webt`, choose `eTranslation` as Translation provider and enter your application name and password.

Then check Machine translation engines ("General Text" should fit in most cases).

Then uncheck `Auto-translate on save/load?` in the Advanced-Tab and save the form.

### Configure TMGMT

Open `/admin/tmgmt/settings` and adapt the settings to your needs. Please note the last section, where referenced entities (such as media or paragraphs) can be translated automatically.

Open `/admin/tmgmt/translators/manage/webt` and adapt the settings to your needs.

### Translate your first entity

Then create a new entity or open an existing entity. Open the "Translate"-Tab. Now you can check all untranslated language versions and click "Request translation". After short time the translation should be done.

